OGRE: Ogre::v1::NodeAnimationTrack Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Member Functions | List of all members
Ogre::v1::NodeAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with node transforms. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::v1::NodeAnimationTrack:
[legend]

## Public Member Functions
| NodeAnimationTrack (Animation *parent, unsigned short handle)
| Constructor. More...
| NodeAnimationTrack (Animation *parent, unsigned short handle, Node *targetNode)
| Constructor, associates with a OldNode. More...
virtual | ~NodeAnimationTrack ()
| Destructor. More...
void | _applyBaseKeyFrame (const KeyFrame *base)
| Internal method to re-base the keyframes relative to a given keyframe. More...
virtual void | _buildKeyFrameIndexMap (const vector< Real >::type &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index. More...
NodeAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only) More...
virtual void | _collectKeyFrameTimes (vector< Real >::type &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format. More...
void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data. More...
virtual void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| Applies an animation track to the designated target. More...
void | applyToNode (Node *node, const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| As the 'apply' method but applies to a specified OldNode instead of associated node. More...
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index. More...
virtual TransformKeyFrame * | createNodeKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index. More...
Node * | getAssociatedNode (void) const
| Returns a pointer to the associated OldNode object (if any). More...
unsigned short | getHandle (void) const
| Get the handle associated with this track. More...
void | getInitialState (Vector3 *outPosition, Quaternion *outOrientation, Vector3 *outScale)
| Get the initial state of the node for this track. More...
virtual void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified. More...
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index. More...
virtual Real | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them. More...
virtual TransformKeyFrame * | getNodeKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index. More...
virtual unsigned short | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation. More...
Animation * | getParent () const
| Returns the parent Animation object for this track. More...
virtual bool | getUseShortestRotationPath () const
| Gets the method of rotation calculation. More...
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes. More...
virtual void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track. More...
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index. More...
void | resetNodeToInitialState (void)
| Resets the the target node to the initial state. More...
void | setAssociatedNode (Node *node)
| Sets the associated OldNode object which will be automatically affected by calls to 'apply'. More...
void | setInitialState (const Vector3 &position, const Quaternion &orientation, const Vector3 &scale)
| Set the initial state of the node for this animation track. More...
virtual void | setListener (Listener *l)
| Set a listener for this track. More...
virtual void | setUseShortestRotationPath (bool useShortestPath)
| Sets the method of rotation calculation. More...

## Detailed Description

Specialised AnimationTrack for dealing with node transforms.

## Constructor & Destructor Documentation

## ◆ NodeAnimationTrack() [1/2]

Ogre::v1::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle
| ) |  |

Constructor.

## ◆ NodeAnimationTrack() [2/2]

Ogre::v1::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | Node * | targetNode
| ) |  |

Constructor, associates with a OldNode.

## ◆ ~NodeAnimationTrack()

virtual Ogre::v1::NodeAnimationTrack::~NodeAnimationTrack | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ _applyBaseKeyFrame()

void Ogre::v1::NodeAnimationTrack::_applyBaseKeyFrame | ( | const KeyFrame * | base | ) |
| virtual

Internal method to re-base the keyframes relative to a given keyframe.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ _buildKeyFrameIndexMap()

virtual void Ogre::v1::AnimationTrack::_buildKeyFrameIndexMap | ( | const vector< Real >::type & | keyFrameTimes | ) |
| virtualinherited

Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.

## ◆ _clone()

NodeAnimationTrack* Ogre::v1::NodeAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only)

## ◆ _collectKeyFrameTimes()

virtual void Ogre::v1::AnimationTrack::_collectKeyFrameTimes | ( | vector< Real >::type & | keyFrameTimes | ) |
| virtualinherited

Internal method to collect keyframe times, in unique, ordered format.

## ◆ _keyFrameDataChanged()

void Ogre::v1::NodeAnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const
| virtual

Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ apply()

virtual void Ogre::v1::NodeAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = `1.0`,
|  | Real | scale = `1.0f`
| ) |  |
| virtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::v1::AnimationTrack.

## ◆ applyToNode()

void Ogre::v1::NodeAnimationTrack::applyToNode | ( | Node * | node,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = `1.0`,
|  | Real | scale = `1.0f`
| ) |  |

As the 'apply' method but applies to a specified OldNode instead of associated node.

## ◆ createKeyFrame()

virtual KeyFrame* Ogre::v1::AnimationTrack::createKeyFrame | ( | Real | timePos | ) |
| virtualinherited

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ createNodeKeyFrame()

virtual TransformKeyFrame* Ogre::v1::NodeAnimationTrack::createNodeKeyFrame | ( | Real | timePos | ) |
| virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ getAssociatedNode()

Node* Ogre::v1::NodeAnimationTrack::getAssociatedNode | ( | void |  | ) | const

Returns a pointer to the associated OldNode object (if any).

## ◆ getHandle()

unsigned short Ogre::v1::AnimationTrack::getHandle | ( | void |  | ) | const
| inlineinherited

Get the handle associated with this track.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getInitialState()

void Ogre::v1::NodeAnimationTrack::getInitialState | ( | Vector3 * | outPosition,
|  | Quaternion * | outOrientation,
|  | Vector3 * | outScale
| ) |  |

Get the initial state of the node for this track.

Remarks
  Node tracks are based from an initial state, which the node is set to every frame before the node animation is applied See NodeAnimationTrack::getInitialState for more information

## ◆ getInterpolatedKeyFrame()

virtual void Ogre::v1::NodeAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf
| ) |  | const
| virtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

Remarks
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::v1::AnimationTrack.

## ◆ getKeyFrame()

virtual KeyFrame* Ogre::v1::AnimationTrack::getKeyFrame | ( | unsigned short | index | ) | const
| virtualinherited

Returns the KeyFrame at the specified index.

## ◆ getKeyFramesAtTime()

virtual Real Ogre::v1::AnimationTrack::getKeyFramesAtTime | ( | const TimeIndex & | timeIndex,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = `0`
| ) |  | const
| virtualinherited

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

Remarks
  At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters

  timeIndex | The time index.
  keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe in case the caller needs it.

Returns
  Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

## ◆ getNodeKeyFrame()

virtual TransformKeyFrame* Ogre::v1::NodeAnimationTrack::getNodeKeyFrame | ( | unsigned short | index | ) | const
| virtual

Returns the KeyFrame at the specified index.

## ◆ getNumKeyFrames()

virtual unsigned short Ogre::v1::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const
| virtualinherited

Returns the number of keyframes in this animation.

## ◆ getParent()

Animation* Ogre::v1::AnimationTrack::getParent | ( |  | ) | const
| inlineinherited

Returns the parent Animation object for this track.

## ◆ getUseShortestRotationPath()

virtual bool Ogre::v1::NodeAnimationTrack::getUseShortestRotationPath | ( |  | ) | const
| virtual

Gets the method of rotation calculation.

## ◆ hasNonZeroKeyFrames()

virtual bool Ogre::v1::NodeAnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const
| virtual

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ optimise()

virtual void Ogre::v1::NodeAnimationTrack::optimise | ( | void |  | ) |
| virtual

Optimise the current track by removing any duplicate keyframes.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ removeAllKeyFrames()

virtual void Ogre::v1::AnimationTrack::removeAllKeyFrames | ( | void |  | ) |
| virtualinherited

Removes all the KeyFrames from this track.

## ◆ removeKeyFrame()

virtual void Ogre::v1::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) |
| virtualinherited

Removes a KeyFrame by it's index.

## ◆ resetNodeToInitialState()

void Ogre::v1::NodeAnimationTrack::resetNodeToInitialState | ( | void |  | ) |

Resets the the target node to the initial state.

Remarks
  This is called everyframe before the animation is applied. @See setInitialState

## ◆ setAssociatedNode()

void Ogre::v1::NodeAnimationTrack::setAssociatedNode | ( | Node * | node | ) |

Sets the associated OldNode object which will be automatically affected by calls to 'apply'.

## ◆ setInitialState()

void Ogre::v1::NodeAnimationTrack::setInitialState | ( | const Vector3 & | position,
|  | const Quaternion & | orientation,
|  | const Vector3 & | scale
| ) |  |

Set the initial state of the node for this animation track.

Remarks
  Node tracks are based from an initial state, which the node is set to every frame before the node animation is applied Most 3D model exporters base each animation frame from a 0 transform, which is the defaults. However in some situations you may want to change this.

Parameters

  position | The initial position to set
  orientation | The initial orientation to set
  scale | The initial scale to set

## ◆ setListener()

virtual void Ogre::v1::AnimationTrack::setListener | ( | Listener * | l | ) |
| inlinevirtualinherited

Set a listener for this track.

## ◆ setUseShortestRotationPath()

virtual void Ogre::v1::NodeAnimationTrack::setUseShortestRotationPath | ( | bool | useShortestPath | ) |
| virtual

Sets the method of rotation calculation.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h